<template>
  <div class="mb-3">
    <textarea
      :id="id"
      v-model="input"
      :class="{'error-field': error}"
      class="shadow appearance-none border rounded
      w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
      :type="type"
      :name="name"
      :placeholder="placeholder"
      @keyup="validateInput"
      @blue="validateInput"
      @input="$emit('update:modelValue', $event.target.value)"
    />
    <div v-if="error" class="ui basic label pointing red error-text">
      {{ error }}
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, toRefs } from 'vue';

export default defineComponent({
  name: 'TextAreaField',
  props: {
    value: {
      type: [String],
      default: null,
    },
    id: {
      type: [String, Number],
      default: null,
    },
    name: {
      type: String,
      default: null,
    },
    type: {
      type: String,
      default: 'text',
    },
    placeholder: {
      type: String,
      default: null,
    },
    regExp: {
      type: String,
      default: null,
    },
    required: {
      type: Boolean,
      default: false,
    },
    toggleValidForm: {
      type: Function,
      required: true,
    },
  },
  setup(props) {
    const input = ref('');
    const error = ref('');
    const { required, toggleValidForm } = toRefs(props);

    const validateInput = () => {
      if (!input.value && required) {
        error.value = 'The Field is required';
        toggleValidForm.value(false);

        return;
      }

      error.value = '';
      toggleValidForm.value(true);
    };

    return { input, error, validateInput };
  },
});
</script>

<style scoped>
  .error-field {
    border: 2px solid red;
  }
  .error-text {
    color: red;
  }
</style>
